char * filetypes[] = {
	"non", "bad", "pcd", "ptx", "txt", "pda", "bin", "chr",
	"pic", "ba3", "da3", "wpd", "sos", "$0D", "$0E", "dir",
	"rpd", "rpi", "$12", "out", "$14", "rpt", "$16", "$17",
	"$18", "adb", "awp", "asp", "$1C", "$1D", "$1E", "$1F",
	"$20", "$21", "$22", "$23", "$24", "$25", "$26", "$27",
	"$28", "$29", "$2A", "$2B", "$2C", "$2D", "$2E", "$2F",
	"$30", "$31", "$32", "$33", "$34", "$35", "$36", "$37",
	"$38", "$39", "$3A", "$3B", "$3C", "$3D", "$3E", "$3F",
	"$40", "$41", "$42", "$43", "$44", "$45", "$46", "$47",
	"$48", "$49", "$4A", "$4B", "$4C", "$4D", "$4E", "$4F",
	"$50", "$51", "$52", "$53", "$54", "$55", "$56", "$57",
	"$58", "$59", "$5A", "$5B", "$5C", "$5D", "$5E", "$5F",
	"pre", "$61", "$62", "$63", "$64", "$65", "$66", "$67",
	"$68", "$69", "$6A", "nio", "$6C", "dvr", "$6E", "hdv",
	"$70", "$71", "$72", "$73", "$74", "$75", "$76", "$77",
	"$78", "$79", "$7A", "$7B", "$7C", "$7D", "$7E", "$7F",
	"$80", "$81", "$82", "$83", "$84", "$85", "$86", "$87",
	"$88", "$89", "$8A", "$8B", "$8C", "$8D", "$8E", "$8F",
	"$90", "$91", "$92", "$93", "$94", "$95", "$96", "$97",
	"$98", "$99", "$9A", "$9B", "$9C", "$9D", "$9E", "$9F",
	"wpf", "mac", "hlp", "dat", "$A4", "lex", "$A6", "$A7",
	"$A8", "$A9", "$AA", "gsb", "arc", "$AD", "$AE", "$AF",
	"src", "obj", "lib", "s16", "rtl", "exe", "str", "tsf",
	"nda", "cda", "tol", "drv", "$BC", "fst", "$BE", "doc",
	"pnt", "scr", "ani", "$C3", "$C4", "$C5", "$C6", "$C7",
	"fon", "fnd", "icn", "$CB", "$CC", "$CD", "$CE", "$CF",
	"$D0", "$D1", "$D2", "$D3", "$D4", "$D5", "$D6", "$D7",
	"$D8", "$D9", "$DA", "$DB", "$DC", "$DD", "$DE", "$DF",
	"lbr", "$E1", "ati", "$E3", "$E4", "$E5", "$E6", "$E7",
	"$E8", "$E9", "$EA", "$EB", "$EC", "$ED", "$EE", "pas",
	"cmd", "$F1", "$F2", "$F3", "$F4", "$F5", "$F6", "$F7",
	"$F8", "img", "int", "ivr", "bas", "var", "rel", "sys",
    };

/*
ProDOS Filetypes

Num	Name	OS	Meaning
========================================================================
$00			typeless
$01	BAD	both	BAD blocks file
$02	PCD	SOS	Pascal CoDe file
$03	PTX	SOS	Pascal TeXt file
$04	TXT	both	ASCII text file
$05	PDA	SOS	Pascal DAta file
$06	BIN	both	BINary file
$07	CHR	SOS	CHaRacter font file
$08	PIC	both	PICture file
$09	BA3	SOS	Business BASIC (SOS) program file
$0A	DA3	SOS	Business BASIC (SOS) data file
$0B	WPD	SOS	Word Processor Document
$0C	SOS	SOS	SOS system file
$0D		SOS	SOS reserved file type
$0E		SOS	SOS reserved file type
$0F	DIR	Both	subDIRectory file
$10	RPD	SOS	RPS data file
$11	RPI	SOS	RPS index file
$12		SOS	Applefile diskcard file
$13		SOS	Applefile model file
$14		SOS	Applefile report format file
$15		SOS	Screen library file
$16		SOS	SOS reserved file type
$17		SOS	SOS reserved file type
$18		SOS	SOS reserved file type
$19	ADB	ProDOS	AppleWorks Database file
$1A	AWP	ProDOS	AppleWorks WordProcessing file
$1B	ASP	ProDOS	AppleWorks Spreadsheet file
$1C-$5F			Reserved
$60-$6F		ProDOS	PC Transporter (Applied Engineering) reserved filetypes
 $60	PRE	ProDOS	ProDOS preboot driver
 $61-$6A	ProDOS	Reserved
 $6B	NIO	ProDOS	PC Transporter BIOS and drivers
 $6C		ProDOS	Reserved
 $6D	DVR	ProDOS	PC Transporter device drivers
 $6E		ProDOS	Reserved
 $6F	HDV	ProDOS	MSDOS HardDisk Volume
$70-$9F			Reserved
$A0	WPF	ProDOS	WordPerfect document file
$A1	MAC	ProDOS	Macrofile
$A2	HLP	ProDOS	Help File
$A3	DAT	ProDOS	Data File
$A4			Reserved
$A5	LEX	ProDOS	Spelling dictionary
$A6-$AB			Reserved
$AC	ARC	ProDOS	General Purpose Archive file
$AD-$AF			Reserved
$B0	SRC	ProDOS	ORCA/M & APW source file
$B1	OBJ	ProDOS	ORCA/M & APW object file
$B2	LIB	ProDOS	ORCA/M & APW library file
$B3	S16	ProDOS	ProDOS16 system file
$B4	RTL	ProDOS	ProDOS16 runtime library
$B5	EXE	ProDOS	APW shell command file
$B6	STR	ProDOS	ProDOS16 startup init file
$B7	TSF	ProDOS	ProDOS16 temporary init file
$B8	NDA	ProDOS	ProDOS16 new desk accessory
$B9	CDA	ProDOS	ProDOS16 classic desk accessory
$BA	TOL	ProDOS	ProDOS16 toolset file
$BB	DRV	ProDOS	ProDOS16 driver file
$BC			Reserved for ProDOS16 load file
$BD	FST		???
$BC			Reserved for ProDOS16 load file
$BF	DOC	ProDOS	document file
$C0	PNT	ProDOS	//gs paint document
$C1	SCR	ProDOS	//gs screen file
$C2	ANI		???
$C3-$C7			Reserved
$C8	FNT	ProDOS	Printer font file
$C9	FND	ProDOS	finder files
$CA	ICN	ProDOS	finder icons
$CB-$DF			Reserved
$E0	LBR	ProDOS	Apple archive library file
$E1			Unknown (unlisted)
$E2	ATI	ProDOS	Appletalk init file
$E3-$EE			Reserved
$EF	PAS	ProDOS	ProDOS Pascal file
$F0	CMD	ProDOS	added command file
$F1-$F8		ProDOS	User defined filetypes (popular ones include:)
 $F1	OVL	ProDOS	Overlay file
 $F2	DBF	ProDOS	Database file
 $F3	PAD	ProDOS	MouseWrite file
 $F4	MCR	ProDOS	AE Pro macro file
 $F5	ECP	ProDOS	ECP batch file
 $F6	DSC	ProDOS	description file
 $F7	TMP	ProDOS	temporary work file
 $F8	RSX	ProDOS	linkable object module
$F9	IMG	ProDOS	ProDOS image file
$FA	INT	ProDOS	Integer BASIC program
$FB	IVR	ProDOS	Integer BASIC variables file
$FC	BAS	ProDOS	AppleSoft BASIC program
$FD	VAR	ProDOS	AppleSoft BASIC variables file
$FE	REL	ProDOS	ProDOS EDASM relocatable object module file
$FF	SYS	ProDOS	ProDOS8 system file
*/

